(function ($) {
  Drupal.behaviors.testswarm = {
    attach: function (context) {
      var logger = {log: {}, info: {}, tests: []};
      var currentModule = 'default';
      
      QUnit.moduleStart = function(module) {
        currentModule = module.name;
        if (!logger.log[currentModule]) {
          logger.log[currentModule] = {};
        }
      };

      QUnit.testStart = function(test) {
        currentTest = test.name;
      };

      QUnit.testDone = function(test) {
        logger.tests.push(test);
      }
      
      QUnit.done = function(data) {
        logger.info = data;
        logger.caller = Drupal.settings.testswarm.caller;
        logger.token = Drupal.settings.testswarm.token;
        
        // Write back to server
        jQuery.ajax({
          type: "POST",
          url: "/testswarm-test-done",
          timeout: 10000,
          data: logger,
          error: function() {
            alert(Drupal.t("Error connecting to server"));
          },
          success: function(){
            if (!Drupal.settings.testswarm.debug || Drupal.settings.testswarm.debug != 'on') {
              window.location = '/testswarm-browser-tests';
            }
          }
        });        
      };
      QUnit.log = function(data) {
        if (!logger.log[currentModule]) {
          logger.log[currentModule] = {};
        }
        if (!logger.log[currentModule][currentTest]) {
          logger.log[currentModule][currentTest] = [];
        }
        logger.log[currentModule][currentTest].push(data);
      };
    }
  };
})(jQuery);